/*


*/

import framebuffer.FrameBuffer;

import java.awt.Color;
import java.util.Properties;
import java.io.FileInputStream;
import java.io.File;
import java.io.IOException;

/**
   Outline of CS 45500 Assignment 1, part 2.
*/
public class Hw1_fade
{
   public static void main(String[] args)
   {
      // Use a properties file to find out
      // which PPM files to use as assets.
      final Properties properties = new Properties();
      try
      {
         properties.load(
            new FileInputStream(
               new File("assets.properties")));
      }
      catch (IOException e)
      {
         e.printStackTrace(System.err);
         System.exit(-1);
      }
      final String file_1 = properties.getProperty("file1"); // 1st ppm file
      final String file_2 = properties.getProperty("file2"); // 2nd ppm file

      // This framebuffer holds the image that will be embedded
      // into two viewports of the larger framebuffer.
      final FrameBuffer fbEmbedded = new FrameBuffer(file_1);

      /******************************************/

      // 0. Copy your code for steps 1 - 12 from Hw1.java.
      // 1. Create a 1000x700 framebuffer with the appropriate background color.
      // 2. Fill the framebuffer with the grid pattern.
      // 3. Create a viewport and fill it with the striped checkerboard pattern.
      // 4. Create a viewport and fill it with the striped disk pattern.
      // 5. Create a viewport and fill it with a flipped copy of the 1st ppm file.
      // 6. Create another viewport and fill it with another flipped copy of the 1st ppm file.
      // 7. Create a viewport that covers the region of the framebuffer that's selected to be copied.
      // 8. Create another viewport to hold a "framed" copy of the previous viewport.
      //    Give this viewport a grayish background color.
      // 9. Create another viewport inside the last, gray viewport, to hold the copy.
      // 10. Copy the selected region's viewport into this last viewport.
      // 11. Load Dumbledore (the 2nd ppm file) into another FrameBuffer.
      // 12. Create a viewport to hold Dumbledore's ghost.
      // 13. Iteratively blend Dumbledore from its framebuffer into the viewport.

      final FrameBuffer fb = null;

      int count = 0;
      // fade Dumbledore by 1% in each iteration.
      for (float fade = 1.0f; fade >= 0.0f; fade-=0.01f)
      {
         // Use fade to blend Dumbledore into the background.


         /******************************************/
         // Save the resulting image in a file.
         final String savedFileName = "Hw1_fade_"+count+".ppm";
         fb.dumpFB2File(savedFileName);
         System.err.println("Saved " + savedFileName);
         ++count;
      }
   }
}
